/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.baselibs;  

import cdac.medinfo.sdk.hl7282.baselibs.segmentfactory.DataElementFactory;
import cdac.medinfo.sdk.hl7282.commoninterface.IDataType;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidComponentTypeException;
import cdac.medinfo.sdk.hl7282.utils.EnumDataType;
import cdac.medinfo.sdk.hl7282.utils.IDataTypeMap;

/**
 * DLT - Delta<p>
 * This data type describes the information that controls delta check warnings.
 * <p>Represents an HL7 DLT data type. 
 * This data type has the following attributes:</p><p>
 *  1.  Normal Range (NR)<b>Optional</b><br>
 *  2. Numeric Threshold (NM)<b>Optional</b><br>
 *  3. Change Computation (ID)<b>Optional</b><br>
 *  4. Days Retained (NM)<b>Optional</b><br><p>
 * This class provides accessors & mutators for the elements mentioned above.
 * This class override the equal method, to check whether some other object is "equal to" this one.
 * 
 * <p>User can also create Data Type through {@link DataElementFactory} 
 */
public class DLT extends CompositeDataType    
{
	

	/**
	 * Default Constructor for DLT
	 */
	public DLT()
	{
		super(EnumDataType.HL7_DT_DLT);
		 
	}

	/**
	 * Constructor  for DLT class which takes four arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */ 
	public DLT(int iMinLength, int iMaxLength, String strCLength,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_DLT);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}

	/**
	 * Constructor for DLT class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public DLT(int iMinLength, int iMaxLength, String strCLength,int iTableNo,int iComponentType) throws InvalidComponentTypeException
	{
		super(EnumDataType.HL7_DT_DLT);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iTableNo = iTableNo;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());		
		}
	}
	/**
	 * Constructor for DLT class which takes two arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public DLT(int iComponentType,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_DLT);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for DLT class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public DLT(int iComponentType,int iMinLength, int iMaxLength, String strCLength,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_DLT);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for DLT class which takes six arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public DLT(int iComponentType,int iMinLength, int iMaxLength, String strCLength,int ITableNo,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_DLT);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iTableNo = ITableNo;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}



	/**
	 *Sets the NormalRange.
	 *@param objNormalRange Specifies the normal interval of the reference data 
	 */
	public void setNormalRange(NR objNormalRange)
	{
		setComponentType(1,objNormalRange);
	}

	/**
	 *Sets the NumericThreshold.
	 *@param strNumericThreshold Specifies the numeric threshold of the change that is detected.  
	 */
	public void setNumericThreshold(String strNumericThreshold)
	{
		if(strNumericThreshold!=null)
			setComponentType(2, strNumericThreshold);
		else
			setNumericThreshold((NM)null);
	}

	/**
	 *Sets the NumericThreshold.
	 *@param objNM Specifies the numeric threshold of the change that is detected. 
	 */
	public void setNumericThreshold(NM objNM)
	{
		setComponentType(2,objNM);
	}

	/**
	 *Sets the ChangeComputation.
	 *@param strChangeComputation Specifies if the change is computed as a percent change or as an absolute change.
	 * 								 [Refer to HL7 Table 0523  Computation type]valid values %,a.
	 */
	public void setChangeComputation(String strChangeComputation)
	{
		if(strChangeComputation!=null)
			setComponentType(3, strChangeComputation);
		else
			setChangeComputation((ID)null);
	}

	/**
	 *Sets the ChangeComputation.
	 *@param strChangeComputation Specifies if the change is computed as a percent change or as an absolute change.
	 * 								 [Refer to HL7 Table 0523  Computation type]valid values %,a.
	 */
	public void setChangeComputation(ID objID)
	{
		setComponentType(3,objID);
	}

	/**
	 *Sets the DaysRetained.
	 *@param strDaysRetained Specifies of time in days that the value is retained for computing delta checks. 
	 */
	public void setDaysRetained(String strDaysRetained)
	{
		if(strDaysRetained!=null)
			setComponentType(4, strDaysRetained);
		else
			setDaysRetained((NM)null);
	}

	/**
	 *Sets the DaysRetained.
	 *@param objNM Specifies of time in days that the value is retained for computing delta checks.
	 */
	public void setDaysRetained(NM objNM)
	{
		setComponentType(4,objNM);
	}

	/**
	 * Returns Normal Range
	 * @return NR - data type.
	 */
	public NR getNormalRange()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(1);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (NR)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Numeric Threshold
	 * @return NM - data type.
	 */
	public NM getNumericThreshold()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(2);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (NM)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Change Computation
	 * @return ID - data type.
	 */
	public ID getChangeComputation()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(3);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Days Retained
	 * @return NM - data type.
	 */
	public NM getDaysRetained()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(4);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (NM)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * This method checks the equality of Object.
	 * @param objObject object of Object class.
	 * @return boolean - shows success or failure of the comparison.
	 */
	public boolean equals(Object objObject)
	{
		if((objObject == null ) || (!(objObject instanceof DLT)))
			return false;

		if(this.getNormalRange() == null)
		{
			if(((DLT)objObject).getNormalRange() != null)
				return false;
		}
		else if(false == (this.getNormalRange().equals(((DLT)objObject).getNormalRange())))
			return false;

		if(this.getNumericThreshold() == null)
		{
			if(((DLT)objObject).getNumericThreshold() != null)
				return false;
		}
		else if(false == (this.getNumericThreshold().equals(((DLT)objObject).getNumericThreshold())))
			return false;

		if(this.getChangeComputation() == null)
		{
			if(((DLT)objObject).getChangeComputation() != null)
				return false;
		}
		else if(false == (this.getChangeComputation().equals(((DLT)objObject).getChangeComputation())))
			return false;

		if(this.getDaysRetained() == null)
		{
			if(((DLT)objObject).getDaysRetained() != null)
				return false;
		}
		else if(false == (this.getDaysRetained().equals(((DLT)objObject).getDaysRetained())))
			return false;

		return true;
	}
}
